

public class SyntaxTree {
	private SyntaxNode root;

	private SyntaxTree() {
		root = null;
	}

	/**
	 * Parse an expression and create a new SyntaxTree.<p>
	 * Expr = Expression ";".<br>
	 * Expression = Term { ( "+" | "-" ) Term }.<br>
	 * Term = Factor { ( "*" | "/" ) Factor }.<br>
	 * Factor = number | "(" Expression ")" | "sqrt" "(" Expression ")".<br>
	 */
	public static SyntaxTree parseExpr() {
		...
	}

	/**
	 * Evaluate SyntaxTree and return result.
	 */
	public double evaluate() {
		...
	}

	public void printAll() {
		...
	}
}
